#ifndef CIRC8_CPP
#define CIRC8_CPP

#ifdef _WIN32
        #include <windows.h>
	#include <shlobj.h>
#endif
                
#include "circuit8.h"

Circuit8* Circuit8::Instance()
{
   static Circuit8 t;
   return &t;
}

Circuit8::Circuit8()
{
	screenidx = 0;
	upscrolls = 0;
//	cout << screenidx << endl;
	int ctr = screenidx;
	for (ctr = 0; ctr < 1024; ctr++) {
//		cout << screenidx << endl;
		for (int i = 0;i<64;i++) {
			for (int p = 0;p<48;p++) {
//				cout << ctr << i << p << endl;
				screen.screen[i][p].r[ctr] = 0;
				screen.screen[i][p].g[ctr] = 0;
				screen.screen[i][p].b[ctr] = 0;
			}
		}
	}
	screenidx = 32;
	screendirection = 1;
}

void Circuit8::moreRed(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].r[screenidx] += amount;
	if (screen.screen[x][y].r[screenidx] > 1.0f) screen.screen[x][y].r[screenidx] = 1.0f;
}

void Circuit8::lessRed(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].r[screenidx] -= amount;
	if (screen.screen[x][y].r[screenidx] < 0) screen.screen[x][y].r[screenidx] = 0;
}

void Circuit8::moreGreen(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].g[screenidx] += amount;
	if (screen.screen[x][y].g[screenidx] > 1.0f) screen.screen[x][y].g[screenidx] = 1.0f;
}

void Circuit8::lessGreen(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].g[screenidx] -= amount;
	if (screen.screen[x][y].g[screenidx] < 0) screen.screen[x][y].g[screenidx] = 0;
}

void Circuit8::moreBlue(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].b[screenidx] += amount;
	if (screen.screen[x][y].b[screenidx] > 1.0f) screen.screen[x][y].b[screenidx] = 1.0f;
}

void Circuit8::lessBlue(unsigned int x, unsigned int y, float amount)
{
	screen.screen[x][y].b[screenidx] -= amount;
	if (screen.screen[x][y].b[screenidx] < 0) screen.screen[x][y].b[screenidx] = 0;
}

Circuit8::~Circuit8()
{
}

#endif